<% 
   function ShowL
      dim i
      i = instr(tsrc,vblf)
      if i = 0 then i = len(tsrc) 
      if i = 0 then ssrc = "" else  ssrc = left( tsrc, i)
      ShowL = ssrc
   end function

   function PrepareBuffer
      ssrc = replace(ssrc,vbcr," ")
      ssrc = " " & trim(replace(ssrc,vblf," ")) & " " 
   end function

   function TakeL
       TakeL = ShowL 
       ' precautions: if nowhere to go, do not go ahead ...
       ' but tsrc must be ended by lf !
       if len(TakeL) < len(tsrc) then
          tsrc = mid(tsrc,len(ssrc)+1)
       else 
          'text_scooped = true   ' this is an alarm for upper levels ...
          tsrc = ""
       end if
   end function

   function OnNewL
       TakeL 
       OnNewL = ShowL
   end function   


   ' takes all right before <33 or div
   ' return may be empty
   ' does not move
   function ShowT
         dim i,w,l
         dim c
             c = div

         l = len(ssrc)         
         for i=1 to l 
		 w = mid(ssrc,i,1)
             if asc(w) < 33 or w = c then exit for
         next
         tock  = left(ssrc, i-1) 
         ShowT = tock
 
   end function
 
   function TakeT
         dim i,w,l
         dim c
             c = div

         TakeT = ShowT
         l = len(TakeT) 
         ' now substruct tocken and all dividors from s
         ssrc = mid(ssrc, l+1 )
         l = len(ssrc)
         for i = 1 to l         
             w = mid(ssrc,i,1)
             if ( asc(w)>32 and w <> c ) or w = vblf then exit for
         next
         ssrc = mid(ssrc,i)
   end function


   ' passes all <33 except lf
   Sub pass_delimiters()
         dim i,w,l
         l = len(ssrc)
         for i = 1 to l         
             w = mid(ssrc,i,1)
             if  asc(w)>32 or w = vblf then exit for
         next
         ssrc = mid(ssrc,i)
   end sub
 
   'storage:
   'function MetaL(c)	' divide by first occurence of string c
   '   dim i
   '   i = instr(tsrc,c)
   '   if i=0 then MetaL = tsrc else MetaL = left(tsrc,i-1)
   'end function

   ' aux fun. for parsing

   function find_state(s)
      dim k
      for k=1 to nstate
 '                if deb then printl "k=" & k & " state=`" & state(k) & "` s=`" & s & "`"
                  if state(k) = s then 
                     find_state = k
                     exit function
                  end if
      next 
      stope "your schema is not complete: state `" & s & "` does not have any events ... "  & _
		ve & " event=`" & exevent(nevent) & "` " & vh & " state nest header starts from =`" & wsequence(1) & "`"
   end function

   ' never tested:
   function find_event(s)
      dim k
      for k=1 to nevent
          if exevent(k) = s then 
             find_event = k
             exit function
          end if
      next 
      stope "fatal error: event " & s & " is not found"
   end function

sub initiate_schema

  

 mmes     = mes & mes	' macro var. escape
 cstart   = ses & "s"	' artificially create internal states
 state(1) = cstart
 istart   = 1

 cdone    = ses & "d"      
 state(2) = cdone
 idone    = 2

 cbegin   = ses & "b"
 state(3) = cbegin
 ibegin   = 3

 cend     = ses & "e"
 state(4) = cend
 iend     = 4

 cneut    = ses
 state(5) = cneut
 ineut    = 5

 cany     = ses & "a"
 'cany	    = ses
 state(6) = cany
 iany	    = 6

 nstate   = 6

 e_id     = ees & "id"
 e_eot    = ees & "eot"
 e_any    = ees & "a"

 a_t      = aes & "t"
 a_p      = aes & "p"
 a_m      = aes & "m"

 extra_event_counter=0
 event_name_reserved = ""
 
end sub




'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
sub find_tock()
  dim i,j,k,l,w,c

  if tock2 <> "" then    ' if tocken was reserved name and stored before
     if deb then printl "..o.. found stored tock2=`" & tock2 & "`"
     tock = tock2
     tock2 = ""
     exit sub
  end if

  ''' SEARCH FOR SEPARATOR ''''''''''''''''
  do 
    j = 0						' a length of found separator
    tock2 = ""				      ' index
    for k=pos to lsrc
        'if deb then printl "moving along the text searching for sep; k=" & k & " j = " & j
        c = mid(tsrc,k,1)
        if asc(c)<33 then 		      ' #32 mode may be made
           'if deb then printl "..o.. found div32=`" & c & "`=" & asc(c)
           j = 1
	     for i=1 to nevent
		   'if deb then printl "comparing seps; now ev/sep is `" & exevent(i) & "`"
      	   if c = exevent(i) and not kword(i) then     ' valid separator is found
			'if deb then printl "..o.. it is sep32"
                  tock2 = c
                  exit for
               end if
           next
           exit for
        end if

        ''' SEARCH FOR TRUE SEPARATORS: NOT AUX LIKE .t AND NOT KEYWORDS
        if tock2 = "" then			' why to search for sep32 two times? ...
          i = 1
          do
           if not kword(i) and textev(i) then 		' look for true separators
             w = exevent(i)
             l=len(w)
             'if deb then printl " seach sep between events; event =`" & exevent(i) & "`"
             if mid( tsrc, k, l ) = w then
                'if deb then printl "..o.. sep33 found =`" & w & "`"
                tock2 = w
                j = l
                exit for
             end if
            end if
            i = i + 1
          loop while i <= nevent
         end if ' tock <> "" then		' why to search for sep32 two times? ...
    next						' for k = ...
    
    
    if k > pos then 
    ''''  WORD IS IN THE THIRS POSITION = SEPARATOR FOUND FAR AHEAD 
       tocken = mid(tsrc, pos, k-pos)
       'if deb then printl "before separator ... analysing word =`" & tocken & "`"
       wi = 0
       i=1
	 
       do
         if kword(i) then 		' look for true keywords
             'if deb then printl " seach for keywords; event =`" & exevent(i) & "`"
             if tocken = exevent(i) then
                'if deb then printl "..o.. keyword found =`" & w & "`"
                tock = tocken
                wi = 1
                exit do
             end if
         end if
         i = i + 1
       loop while i <= nevent


    ''' THE WORD IS NOT A KEYWORD; HANDLE IT       
       if wi = 0 then tock = e_id    ' tocken aready defined ...
       pos = k+j
       ttype = get_ttype
       'if deb then printl "..o.. leaving sub with tock=id, tocken=`" & tocken & "`"  
       exit sub				' tock2 may be = 0, may be not 
    ''' END THE WORD HANDLING

    else     	
    ''' SEPARATOR IS IN THE FIRST POSITION: k=pos
       pos = k+j
       if tock2 <> "" then		' if not pure separator
          tock = tock2
          tock2 = ""
          'if deb then printl "..o.. leaving fun with no tock2, tock=`" & tock & "`" & " j=" & j
          exit sub
       end if 
    ''' END HANDLING SEPARATOR IN THE FIRST POSITION
    end if	

loop while pos <= lsrc 		' cycle along the text by pos

eot  = true
tock = e_eot
if deb then printl e_eot & " found ... "

end sub


function take_asc(s)
  dim i
  take_asc = ""
  if IsNumeric(s) then 
	i = Cint(s)
	if i >=0 and i < 256 then 
	   take_asc = chr(i)
      end if
  end if
  if take_asc = "" then stope "error asc value = `" & s & "`"
end function

function create_new_event(s,cont)

  if deb then printpi "creating a new event = `" & s & "`"
  extra_event_counter = extra_event_counter + 1
  nextra_event = nextra_event + 1
  if nextra_event > l_nextra_event then 
     stope "no space in extra_event array ... "
  end if
  
  if cont = "text" then
	  extra_event_action(nextra_event) = s 
	  extra_event(nextra_event)= ees & "!" & ees & Cstr(extra_event_counter) 
  else 
	  stope "unknown control ..."
  end if
  create_new_event = extra_event(nextra_event)

end function

sub add_extra_events   
    dim i,k,ws,wi
    if nextra_event < 1 then exit sub
    if deb then printl ve & "*** adding extra events ... " & ve
    for i=1 to  nextra_event
        increase_nevent
        exevent(nevent) = extra_event(i) 
        action(nevent)  = extra_event_action(i)
        act_text(nevent) = true	' just to print

        states_sequence(nevent,1) = cany
        index_sequence(nevent,1)  = iany
        nsequence(nevent)=1

	  kword(nevent) = false
        textev(nevent) = false	
        level(nevent) = 0

	  nnext(nevent) = 1				' for next states
        next_index(nevent, 1) = ineut		' for next states

        nnextev(nevent) = 0
        feed_back(nevent) = ""
        store_fragment(nevent) = 0
        report_event
        if deb then printl "...... in states: "
        for k = nsequence(nevent) to 1 step -1
            if deb then printl ".......... " &  states_sequence(nevent,k)
        next
     next
end sub              


sub increase_nevent
    nevent = nevent + 1
    if nevent >= levent then stope "array size = 'levent' is too small ..."
end sub        

sub report_event
       if deb then
         ws = exevent(nevent) 
         wi = asc(ws)
 	   if wi < 32 or wi > 127 then  ws = ees & wi
   	   printl "added event " & nevent & "  =`" & ws & "`" 
         printl "...... action=`" & action(nevent) & "`"
         printl "...... act_text(nevent)=" & act_text(nevent) 
         printl "...... kword=" & kword(nevent)
         printl "...... level=" & level(nevent)
         printl "...... nnext(nevent)=" & nnext(nevent)
         prints "...... next_state(s)=" : for k=1 to nnext(nevent) : prints state(next_index(nevent, k)) &  "  " : next : prints ve
         printl "...... next events #=" & nnextev(nevent)
         if nnextev(nevent) > 0 then
	         prints "...... next_events(s)=" : for k=1 to nnextev(nevent) : prints next_event(nevent, k) &  "  " : next : prints ve
	   end if
         printl "...... feed_back="  & feed_back(nevent)
         printl "...... store_fragment="  & store_fragment(nevent)
       end if
end sub

function get_ttype
       dim s,a
       get_ttype = "i"
       s = left(tocken,1)
       a = asc(s)
       if a>47 and a<58 then 
          get_ttype="n"
          exit function
       elseif s = chr(34) then
          get_ttype="s"
          exit function
       end if 
end function

%>
